//+--------------------------------------------------------------------------------------------------------------------+
//|                                                                                                       SetOrder.mqh |
//|          ( digits)                                                 |
//+--------------------------------------------------------------------------------------------------------------------+
class SetOrder
 {
   private: 
            string symb;                           // , 
            int tp;                                //    4-  
            int sl;                                //    4-  
            int magN;                              //  
            double lot;                            //  
            double myPoint;                        //  
            ENUM_ORDER_TYPE typeOrd;
         
   public: 
           SetOrder(){}                            //   
           
           SetOrder(string sy, ENUM_ORDER_TYPE tip, double ll, int stl, int tkp, int mn){     //   
             symb = sy;
             typeOrd = tip;
             lot = ll;
             sl = stl;
             tp = tkp;
             magN = mn;
             if(_Digits==3 || _Digits==5){myPoint=_Point*10;}
             else myPoint=_Point; 
           }
           
           SetOrder(string sy, ENUM_ORDER_TYPE tip, double ll, int mn){     //   
             symb = sy;
             typeOrd = tip;
             lot = ll;
             magN = mn;
             tp=0; sl=0;
             if(_Digits==3 || _Digits==5){myPoint=_Point*10;}
             else myPoint=_Point;
             Print("  ");
           }

          
          ~SetOrder(){}                            // 
           
           void set();                             //  
  
 };  // End class
 
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
//    ,      TP/SL
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
void SetOrder::set(){  
   double bid, ask;                                         //   Bid  Ask,    TP/SL
   double TP, SL;                                           //    
   TP = SL = 0;
   MqlTradeRequest request={0};                             // ,   " "
   MqlTradeResult  result={0};                              // ,   " "
   bid = SymbolInfoDouble(symb,SYMBOL_BID); 
   ask = SymbolInfoDouble(symb,SYMBOL_ASK); 
//+--------------------------------------------------------------------------------------------------------------------+
      if(typeOrd==0 && (tp>0 || sl>0) ){                    //  ,   TP/SL
         TP = NormalizeDouble(ask+tp*myPoint, _Digits);   
         SL = NormalizeDouble(bid-sl*myPoint, _Digits);
      }
      if(typeOrd==1 && (tp>0 || sl>0) ){                    //  ,    TP/SL
         TP = NormalizeDouble(bid-tp*myPoint, _Digits);
         SL = NormalizeDouble(ask+sl*myPoint, _Digits);
      }
//+--------------------------------------------------------------------------------------------------------------------+
   request.action = TRADE_ACTION_DEAL;                      //   
   request.symbol = symb;                                   // 
   request.volume = lot;                                    // 
   request.type = typeOrd;                                  //  
   request.type_filling = ORDER_FILLING_RETURN;             //     .
   request.magic = magN;                                    // ORDER_MAGIC
   request.comment = (string)magN;                          //      
   OrderSend(request,result);                               //     
//+--------------------------------------------------------------------------------------------------------------------+
   if(result.deal>0 && (TP>0 || SL>0) ){
   
    long stLev=SymbolInfoInteger(symb, SYMBOL_TRADE_STOPS_LEVEL);  //  StopLevel  
    if(sl<stLev || tp<stLev){
      Print("  SL/TP   StopLevel");
      return;
    }  
    
    request.action = TRADE_ACTION_SLTP;                           //   
    request.symbol = symb;                                        // 
    request.sl = SL;                                              //  
    request.tp = TP;                                              //  
    OrderSend(request,result);                                    //     
    Print(" - ", __FUNCTION__," - ",result.comment);
    if(result.retcode==10016) Print(result.bid,result.ask,result.price);    
   }
   else{ 
    Print("  - ", __FUNCTION__,":",result.comment," ",result.retcode);
    if(result.retcode==10016) Print(result.bid,result.ask,result.price);
   }
//+--------------------------------------------------------------------------------------------------------------------+
  }
//+--------------------------------------------------------------------------------------------------------------------+
 